#ifndef DLL_H
#define DLL_H

#include <stdio.h>

#ifdef DLL_CTYPE
#define CTYPE_PLAIN	1
#define S_CTYPE		INT ctype;
#else
#define S_CTYPE
#endif

#ifdef DLL_MARK
#define S_MARK		INT mark;
#else
#define S_MARK
#endif

#define DLL_GETNEXT	1
#define DLL_GETPREV	2
#define DLL_FREE	4
#define DLL_SORTASC	1
#define DLL_SORTDESC	2
#define DLL_CHECKPREV	1
#define DLL_CHECKNEXT	2
#define DLL_SHOWHEAD	1
#define DLL_LOOPCHECK	2

#define DLLHEAD		struct dll_s	*next; 	\
			struct dll_s	*prev; 	\
			S_CTYPE			\
			S_MARK

typedef struct dll_s {	DLLHEAD
			CHAR		data[1];	} dll_t;

VOID clearChain(dll_t *head);
VOID deleteChain(dll_t *head);
dll_t *initChain(dll_t *head);
INT isEmptyChain(dll_t *head);
dll_t *removeElement(dll_t *elem, INT flag);
#ifdef DLL_MARK
VOID clearByMark(dll_t *head, INT mark);
VOID deleteByMark(dll_t *head, INT mark);
#endif
VOID insertAtHead(dll_t *head, dll_t *elem);
VOID insertAtTail(dll_t *head, dll_t *elem);
VOID insertAfter(dll_t *where, dll_t *elem);
VOID insertBefore(dll_t *where, dll_t *elem);
VOID exchangeElements(dll_t *elem1, dll_t *elem2);
#ifdef DLL_MARK
VOID sortByMark(dll_t *head, INT flag);
dll_t *getByMark(dll_t *head, dll_t *start, INT mark);
#endif
dll_t *getNext(dll_t *head, dll_t *start);
VOID dumpChain(FILE *fd, dll_t *head, dll_t *start, INT flag, INT bodyflag, VOID (* dumpbody)());
dll_t *loopCheck(dll_t *head, INT flag); 
INT addPlain(dll_t *head, 
#ifdef DLL_MARK
             INT mark, 
#endif
             VOID *data, size_t length);
/*
undef S_CTYPE
undef S_MARK
*/
#endif /* DLL_H */


